/* ============================================================================================= *
 * file:    zarray.h
 * created: 2002-03-25
 * coder:   [kon]
 * update:  2002-03-26
 * version: 0.2
 *
 * desc:        Template fr ein Array
 *              supported features:
 *               Add,Remove x2, RemoveAll, []
 * to do:       Copy-Konstruktor, operator
 * ============================================================================================= */

#ifndef zarray_h
#define zarray_h



#include <windows.h>
#include <stdlib.h>
#include <assert.h>


template <typename T> class zArray
{
private:
   /* ich verwenden T** um die leichte Mglichkeit zu geben Array Items einfach zu lschen.
    * Um einen Eintrag in der Mitte zu lschen, muss man so nur das Item lschen den Pointer 
    * vom Ende in den zu lschenden Eintrag kopieren und schon wurde der Eintrag gelscht.
    * Dadurch verndert sich zwar die Pointer Lage (Pointers: ABCD -> Lsche B -> ADC) jedoch
    * erspart man sich so groe Klassen zu kopieren. Besserer Weg: Linked List???
    */
   T**  mppFront;        // Erster Eintrag
   T*  mpTraversal;    // Zur Durchforstung
   unsigned int miNumItems;     // Anzahl der Eintrge
public:
   zArray();
   ~zArray();

   unsigned int GetNum() const;
   // Speichert val in Array ab
   void Add(const T& val);
   // Lscht Items die den gleichen Wert haben wie val
   void Remove(const T& val);
   // Lscht den Eintrag[ind]
   void Remove(unsigned int ind);
   void RemoveAll();

   T& operator[](unsigned int ind) const;
};


#include "zarray.inl"



#endif
