/* ============================================================================================= *
 * file:    zarray.h
 * created: 2002-03-25
 * coder:   [kon]
 * ============================================================================================= */


/*************************************************************************************************/
/*************************************************************************************************/
// ***** Funcs


template <typename T> zArray<T>::zArray()
{
   mppFront = NULL;
   mpTraversal = NULL;
   miNumItems = 0;
}

/*************************************************************************************************/

template <typename T> zArray<T>::~zArray()
{
   RemoveAll();
}

/*************************************************************************************************/

template <typename T> unsigned int zArray<T>::GetNum() const
{
   return miNumItems;
}

/*************************************************************************************************/

template <typename T> void zArray<T>::Add(const T& val)
{
   T** backup = mppFront;

   mppFront = (T**) realloc(mppFront,(miNumItems+1)*sizeof(T*));
   if (mppFront == NULL) {
      mppFront = backup;
      return;
   }

   mppFront[miNumItems] = new T;
   *mppFront[miNumItems] = val;

   miNumItems++;
}

/*************************************************************************************************/

template <typename T> void zArray<T>::Remove(const T& val)
{
   assert(mppFront);

   T** backup;
   for (int i=0; i < miNumItems; i++) {
      if (*mppFront[i] == val) {
         delete mppFront[i];
         --miNumItems;
         if (i != miNumItems) {
            mppFront[i] = mppFront[miNumItems];
            mppFront[miNumItems] = NULL;
            --i;
         }
         if (miNumItems > 0) {
            backup = mppFront;
            mppFront = (T**) realloc(mppFront, (miNumItems)*sizeof(T*));
            if (mppFront == NULL)
               mppFront = backup;
         }
         else {
            mppFront = NULL;
         }
      }
   }
}

/*************************************************************************************************/

template <typename T> void zArray<T>::Remove(unsigned int ind)
{
   assert(mppFront && (ind<miNumItems));

   T** backup;

   delete mppFront[ind];
   --miNumItems;
   if (ind != miNumItems) {
      mppFront[ind] = mppFront[miNumItems];
      mppFront[miNumItems] = NULL; 
   }
   if (miNumItems > 0) {
      backup = mppFront;
      mppFront = (T**) realloc(mppFront, miNumItems*sizeof(T*));
      if (mppFront == NULL)
         mppFront = backup;
      return;
   }
   mppFront = NULL;
}

/*************************************************************************************************/

template <typename T> void zArray<T>::RemoveAll()
{
   if (mppFront == NULL) return;
   for (unsigned int i=0; i < miNumItems; i++) {
      delete mppFront[i];
      mppFront[i] = NULL;
   }
   free(mppFront);
   mppFront = NULL;
   mpTraversal = NULL;
   miNumItems = 0;
}

/*************************************************************************************************/

template <typename T> T& zArray<T>::operator[](unsigned int ind) const
{
   assert(mppFront && (ind < miNumItems));
   return *mppFront[ind];
}

/*************************************************************************************************/
