/* ============================================================================================= *
 * file:    console_cmds.h
 * created: 2002-03-27
 * coder:   [kon]
 * ============================================================================================= */

/*************************************************************************************************/
/*************************************************************************************************/
// ***** Includes

#include <windows.h>
#include <d3d8.h>
#include "zed4d.h"
#include "zhelp.h"
#include "zstring.h"
#include "zarray.h"
#include "zconsole.h"
#include "zconsole_cmds.h"
#include "main.h"


/*************************************************************************************************/
/*************************************************************************************************/
// ***** command funcs

void Console_Quit(zConsoleCommand &command)
{
   Con.SendMessage("Quitting the Program...");
   PostMessage(g_hMainWnd,WM_CLOSE,0,0);
}

/*************************************************************************************************/

void Console_BackgroundColor(zConsoleCommand &command)
{
   int r = _clamp(command.GetVar(0).i, 0, 255);
   int g = _clamp(command.GetVar(1).i, 0, 255);
   int b = _clamp(command.GetVar(2).i, 0, 255);

   backgroundcolor = (r<<16) + (g<<8) + b;

   zString str;
   str.Format("Background Color: red: %d, green: %d, blue: %d",r,g,b);
   Con.SendMessage(str);
}

/*************************************************************************************************/

void Console_About(zConsoleCommand &command)
{
   zString info;
   info.Format("Version %s", Con.GetVersionString());

   Con.SendMessage("");
   Con.SendMessage("-----------------------------------");
   Con.SendMessage("           Zed4D Console           ");
   Con.SendMessage(zString(" ") + info);
   Con.SendMessage(" (c)Copyright 2002 Kongo");
   Con.SendMessage(" E-mail: kongo@gmx.at");
   Con.SendMessage(" http://members.tripod.de/DAKongo/ ");
   Con.SendMessage("-----------------------------------");
   Con.SendMessage("");
}

/*************************************************************************************************/

void Console_Version(zConsoleCommand &command)
{
   zString info;
   info.Format("Version: %s", Con.GetVersionString());
   Con.SendMessage(info);
}

/*************************************************************************************************/

void Console_ShowAllCommands(zConsoleCommand &command)
{
   zString helpstr;

   Con.AddLineToHistory(zString("......Showing all commands......"));
   for (int i=0; i < Con.mpCommands.GetNum(); i++) {
      helpstr = Con.mpCommands[i].GetCommandString() + zString(" ") + Con.mpCommands[i].GetHelpString();
      Con.AddLineToHistory(helpstr);
   }
   Con.AddLineToHistory(zString("......All commands listed......"));
}

/*************************************************************************************************/

void Console_Help(zConsoleCommand &command)
{
   Con.SendMessage("To show all available commands, write: showallcommands");
}

/*************************************************************************************************/

void Console_ShowFps(zConsoleCommand &command)
{
   showfps = command.GetVar(0).b;
   if (showfps) {
      Con.SendMessage("Show FPS");
      return;
   }
   Con.SendMessage("hide FPS");
}

/*************************************************************************************************/



/*************************************************************************************************/
