/* ============================================================================================= *
 * file:    zstring.h
 * created: 2002-03-23
 * coder:   [kon]
 * update:  2002-03-27
 * version: 1.1
 *
 * desc:        String-Kapselung. Gut fr DLL Export
 *              Operatoren, Spacelschung, Sub-String return, Reduce, Scan
 * to do:       finished version 1.0; new features version 2.0:
 *              inlining?
 *              lower und higher: abcd ABCD 
 *              IsEqual, Unterscheidung Gro/Kleinschreibung ja und nein
 *  message.Split(spacePos, true, commandString, paramString);
 *  message.FromatAdd()
 * ============================================================================================= */

#ifndef zstring_h
#define zstring_h



class /*DECL_EXPORT*/ zString
{
private:
   char* str;
public:
   // init
   zString (const char* s = 0);
   zString (const zString& s);
   ~zString ();

   char* GetString() { return str; }
   void Format(char* str, ...);

   // funcs
   int Find(const char *p) const;
   int Find(const zString& s) const;
   unsigned int Length() const;
   void MakeLower();
   // Entfernt alle Leerzeichen: links, rechts, oder an beiden Enden 
   void TrimL();
   void TrimR();
   void TrimAll();
   // Liefert Teilstring zurck
   zString SubL(int len) const; // Teilstring von links
   zString SubR(int len) const; // Teilstring von rechts
   zString SubAll(int pos, int len) const; // Teilstring von pos mit Lnge len
   // Lscht gleiche hintereinanderfolgende Zeichen
   void Reduce(char* reducechars);
   // berprueft das Vorhandensein eines Zeichens im String
   int Scan(char c) const;

   // operators
   zString& operator= (const zString& s);
   zString& operator= (const char* s);
   inline operator const char* () const;
   zString& operator +=(const char *s);
   zString operator+(const zString& s) const;
   zString operator+(const char* s) const;
   char& operator[](int ind) const;

   // comparison
   bool operator== (const zString& s) const;
   bool operator== (const char* s) const;
   bool operator!= (const char* s) const;
   bool operator!= (const zString& s) const;
   bool operator<(const zString& s) const;
   bool operator<(const char * s) const;
   bool operator>(const zString& s) const;
   bool operator>(const char * s) const;

};


inline zString::operator const char* () const
{
   return str;
}



#endif
